---
title: Supporting Resources
---

Great Expectations requires a Python compute environment and access to data, either locally or through a database or distributed cluster. In addition, developing with Great Expectations relies heavily on tools in the Python engineering ecosystem: pip, virtual environments, and Jupyter Notebooks. We also assume some level of familiarity with Git and version control.

See the links below for good, practical tutorials for these tools.

#### pip
* [https://pip.pypa.io/en/stable/](https://pip.pypa.io/en/stable/)
* [https://www.datacamp.com/community/tutorials/pip-python-package-manager](https://www.datacamp.com/community/tutorials/pip-python-package-manager)

#### Virtual Environments
* [https://virtualenv.pypa.io/en/latest/](https://virtualenv.pypa.io/en/latest/)
* [https://python-guide-cn.readthedocs.io/en/latest/dev/virtualenvs.html](https://python-guide-cn.readthedocs.io/en/latest/dev/virtualenvs.html)
* [https://www.dabapps.com/blog/introduction-to-pip-and-virtualenv-python/](https://www.dabapps.com/blog/introduction-to-pip-and-virtualenv-python/)
  
#### Jupyter Notebooks and Jupyter Lab
* [https://jupyter.org/](https://jupyter.org/)
* [https://jupyterlab.readthedocs.io/en/stable/](https://jupyterlab.readthedocs.io/en/stable/)
* [https://towardsdatascience.com/jupyter-lab-evolution-of-the-jupyter-notebook-5297cacde6b](https://towardsdatascience.com/jupyter-lab-evolution-of-the-jupyter-notebook-5297cacde6b)

#### Git
* [https://git-scm.com/](https://git-scm.com/)
* [https://www.atlassian.com/git/tutorials](https://www.atlassian.com/git/tutorials)

